{%- from 'components/freigabestatus_badge.html.jinja' import freigabestatus_badge -%}
{%- from 'components/freigabestatus_badge.html.jinja' import freigabestatus_leistung -%}
{%- from 'components/leistungsschluessel_badge.html.jinja' import leistungsschluessel_badge -%}
{%- from 'components/bob_badge.html.jinja' import bob_badge -%}
{%- from 'components/search_result_description.html.jinja' import search_result_description -%}
{%- from 'components/tab_navigation.html.jinja' import search_nav_link -%}
{%- from 'components/search.html.jinja' import search_bar -%}
{%- from 'components/help.html.jinja' import glossary_link -%}
{%- from 'components/logo.html.jinja' import redaktion_logo_small -%}
{%- from 'components/xzufi_modules.html.jinja' import sdg_relevant -%}
{%- extends "root.html.jinja" -%}

{% block page %}
  <div
    id="web-search"
    hx-boost="true"
    hx-select="#web-search"
    hx-target="#web-search"
    hx-swap="outerHTML show:body:top"
  >
    <h1 class="visually-hidden">Suche</h1>
    <form
      class="d-flex flex-column flex-lg-row"
      id="search"
      method="GET"
      action="/search"
      hx-trigger="change"
    >
      {# sidebar #}
      <aside
        class="sidebar small bg-body-tertiary"
        aria-label="Suchfilter"
        id="search-filters"
      >
        <div class="sidebar-content pt-3 pb-2">
          <div class="container mb-3 border-bottom">
            <h2 class="fs-6">Suche nach</h2>
            <div class="card my-3">
              <ul
                class="nav nav-underline d-flex flex-row mx-2 mt-1 mb-0"
                id="tabs"
                role="tablist"
              >
                {% for baustein_link in baustein_links %}
                  {{ search_nav_link(None, baustein_link.label, baustein_link.get_href(), baustein_link.is_active, None) }}
                {% endfor %}
              </ul>
              <hr class="mt-0 mb-1" />

              <div class="nav nav-pills flex-column gap-1 p-2">
                {% for resource_links in search_result.resource_links_by_category %}
                  {% if resource_links.category is not none %}
                    <div
                      class="px-3 d-flex align-items-center text-muted small pt-2"
                    >
                      <span class="me-2"
                        >{{ resource_links.category.label }}</span
                      >
                      {{ glossary_link(resource_links.category.glossary_link, resource_links.category.label) }}
                    </div>
                  {% endif %}

                  {% for link in resource_links.links %}
                    <a
                      class="nav-link {% if link.is_active %}
                        bg-primary text-white
                      {% endif %} d-flex flex-row gap-2 align-items-center justify-content-between fw-semibold"
                      {% if link.is_active %}
                        aria-current="page"
                      {% endif %}
                      href="{{ link.href }}"
                    >
                      {{ link.get_label() }}
                      <span class="badge text-bg-dark rounded-pill"
                        >{{ link.count }}</span
                      >
                    </a>
                  {% endfor %}
                {% endfor %}
              </div>
            </div>
          </div>
          <div class="container">
            <div class="d-flex flex-row justify-content-between mb-2">
              <h2 class="fs-6">
                Filter {% if active_filters %}({{ active_filters }}){% endif %}
              </h2>
              {% if active_filters %}
                <a href="{{ remove_filters_link }}">Filter entfernen</a>
              {% endif %}
            </div>

            {% if search_result.predefined_filters %}
              <p class="mb-1">Filtervorlagen</p>

              <div class="d-flex flex-row flex-wrap gap-2 mb-3">
                {% for filter in search_result.predefined_filters %}
                  <a
                    class="btn btn-sm btn-light"
                    href="{{ filter.link }}"
                    aria-label="Filtervorlage {{ filter.name }}"
                    >{{ filter.name }}</a
                  >
                {% endfor %}
              </div>
            {% endif %}

            {% for ui_filter in search_result.ui_multi_select_filters %}
              <label for="select_{{ ui_filter.parameter_name }}"
                >{{ ui_filter.label }}{% if ui_filter.glossary_link %}
                  {{ glossary_link(ui_filter.glossary_link, ui_filter.label) }}
                {% endif %}</label
              >
              <ul
                id="select_{{ ui_filter.parameter_name }}"
                class="list-group list-group-flush mt-1 mb-3 multi-select-filter"
              >
                {% for option in ui_filter.options %}
                  <li class="list-group-item multi-select-filter-item">
                    <input
                      type="checkbox"
                      id="{{ option.value }}"
                      name="{{ option.query_param_name }}"
                      {% if option.is_active %}checked{% endif %}
                    />
                    <label for="{{ option.value }}">{{ option.label }}</label>
                  </li>
                {% endfor %}
              </ul>
            {% endfor %}

            {% for ui_filter in search_result.ui_single_select_filters %}
              <label for="select_{{ ui_filter.parameter_name }}"
                >{{ ui_filter.label }}{% if ui_filter.glossary_link %}
                  {{ glossary_link(ui_filter.glossary_link, ui_filter.label) }}
                {% endif %}</label
              >
              <select
                id="select_{{ ui_filter.parameter_name }}"
                name="{{ ui_filter.parameter_name }}"
                class="form-select form-select-sm mt-1 mb-3 {% if not ui_filter.is_active %}text-muted{% endif %}"
                aria-label="{{ ui_filter.label }}"
              >
                {% for option in ui_filter.options %}
                  <option
                    value="{{ option.value }}"
                    {% if option.is_active %}selected{% endif %}
                  >
                    {{ option.label }}
                  </option>
                {% endfor %}
              </select>
            {% endfor %}
          </div>
        </div>
      </aside>

      {# search results #}
      <div class="container py-3 min-vh-100">
        {# search input controls #}
        <section aria-label="Sucheingabe">
          {{ search_bar(search_result.search_bar, search_result.total_count, search_result.elapsed_milliseconds, search_result.csv_download_url) }}
          <input
            type="hidden"
            name="resource"
            value="{{ filters.resource.value }}"
          />
          <input type="hidden" name="page_size" value="{{ page_size }}" />
          <button type="submit" class="d-none" />
        </section>

        {# results list #}
        <section aria-label="Suchergebnisse">
          <h2 class="visually-hidden">Ergebnisse</h2>
          {% if search_result.results %}
            <div hx-boost="false" class="mb-5">
              {%- if filters.resource.value == "schema" -%}
                {%- for schema in search_result.results -%}
                  <article class="search-result">
                    <a href="{{ schema.detail_link }}" class="link-dark">
                      <h3 class="fs-5 fw-semibold mb-0">{{ schema.name }}</h3>
                    </a>
                    {{ search_result_description(schema.beschreibung) }}
                    <div
                      class="d-flex justify-content-between align-items-center flex-wrap gap-2"
                    >
                      <span class="text-muted">
                        <span
                          >{{ schema.fim_id }} • {{ schema.fim_version }} •
                          {{ schema.last_update }} •
                          {{ schema.xdf_version }}</span
                        >
                      </span>
                      {{ freigabestatus_badge(schema.freigabe_status) }}
                    </div>
                  </article>
                {%- endfor -%}
              {%- elif filters.resource.value == "document-profile" -%}
                {%- for steckbrief in search_result.results -%}
                  <article class="search-result">
                    <a href="{{ steckbrief.detail_link }}" class="link-dark">
                      <h3 class="fs-5 fw-semibold mb-0">
                        {{ steckbrief.name }}
                      </h3>
                    </a>
                    {{ search_result_description(steckbrief.beschreibung) }}
                    <div
                      class="d-flex justify-content-between align-items-center flex-wrap gap-2"
                    >
                      <span class="text-muted">
                        <span
                          >{{ steckbrief.fim_id }} •
                          {{ steckbrief.fim_version }} •
                          {{ steckbrief.last_update }} •
                          {{ steckbrief.xdf_version }}</span
                        >
                      </span>
                      {{ freigabestatus_badge(steckbrief.freigabe_status) }}
                    </div>
                  </article>
                {%- endfor -%}
              {% elif filters.resource.value == "group" %}
                {%- for group in search_result.results -%}
                  <article class="search-result">
                    <a href="{{ group.detail_link }}" class="link-dark">
                      <h3 class="fs-5 fw-semibold mb-0">{{ group.name }}</h3>
                    </a>
                    {{ search_result_description(group.beschreibung) }}
                    <div
                      class="d-flex justify-content-between align-items-center flex-wrap gap-2"
                    >
                      <span class="text-muted">
                        <span
                          >{{ group.fim_id }} • {{ group.fim_version }} •
                          {{ group.last_update }} •
                          {{ group.xdf_version }}</span
                        >
                      </span>
                      {{ freigabestatus_badge(group.freigabe_status) }}
                    </div>
                  </article>
                {%- endfor -%}
              {% elif filters.resource.value == "field" %}
                {%- for field in search_result.results -%}
                  <article class="search-result">
                    <a href="{{ field.detail_link }}" class="link-dark">
                      <h3 class="fs-5 fw-semibold mb-0">{{ field.name }}</h3>
                    </a>
                    {{ search_result_description(field.beschreibung) }}
                    <div
                      class="d-flex justify-content-between align-items-center flex-wrap gap-2"
                    >
                      <span class="text-muted">
                        <span
                          >{{ field.fim_id }} • {{ field.fim_version }} •
                          {{ field.last_update }} •
                          {{ field.xdf_version }}</span
                        >
                      </span>
                      {{ freigabestatus_badge(field.freigabe_status) }}
                    </div>
                  </article>
                {%- endfor -%}
              {% elif filters.resource.value == "service" %}
                {%- for service in search_result.results -%}
                  <article class="search-result">
                    <a href="{{ service.detail_link }}" class="link-dark">
                      <h3 class="fs-5 fw-semibold mb-0">{{ service.title }}</h3>
                    </a>

                    {{ search_result_description(service.beschreibung) }}

                    {% if service.redaktionen_overview %}
                      <div class="d-flex flex-column">
                        <div class="d-flex justify-content-start">
                          <a
                            href="#after-redaktionen-{{ loop.index }}"
                            class="btn btn-light btn-sm visually-hidden-focusable w-auto mb-2"
                          >
                            Portalverbund-Links überspringen
                          </a>
                        </div>

                        <div class="d-flex flex-wrap flex-row gap-1">
                          {% for redaktion in service.redaktionen_overview %}
                            <a
                              href="{{ redaktion.href }}"
                              class="d-flex flex-row gap-2 align-items-center rounded border px-2 py-1"
                            >
                              {% if redaktion.icon %}
                                {{ redaktion_logo_small(redaktion.icon) }}
                              {% endif %}
                              {{ redaktion.label }}
                            </a>
                          {% endfor %}
                        </div>

                        <div id="after-redaktionen-{{ loop.index }}"></div>
                      </div>
                    {% endif %}

                    <div
                      class="d-flex justify-content-between align-items-center flex-wrap gap-2"
                    >
                      <span
                        class="text-muted d-flex flex-row align-items gap-2"
                      >
                        {{ service.leistungsschluessel }}
                        {% if service.typ %}
                          ({{ service.typ }})
                        {% endif %}
                        <span> • </span>
                        {{ service.typisierung }}
                        {% if service.header_date_string %}
                          <span> • </span>
                          {{ service.header_date_string }}
                        {% endif %}
                        {{ sdg_relevant(service.sdg_relevanz) }}
                      </span>
                      <div class="d-flex flex-row flex-wrap gap-2">
                        {{ freigabestatus_leistung("Katalog", service.freigabestatus_katalog) }}
                        {{ freigabestatus_leistung("Bibliothek", service.freigabestatus_bibliothek) }}
                      </div>
                    </div>
                  </article>
                {%- endfor -%}
              {% elif filters.resource.value == "service-description" %}
                {%- for service in search_result.results -%}
                  <article class="search-result">
                    <a href="{{ service.detail_link }}" class="link-dark">
                      <h3 class="fs-5 fw-semibold">{{ service.title }}</h3>
                    </a>

                    {{ search_result_description(service.beschreibung) }}

                    <div
                      class="d-flex justify-content-between align-items-center flex-wrap gap-2"
                    >
                      <span
                        class="text-muted d-flex flex-row align-items-center gap-1"
                      >
                        {% if service.redaktion_icon %}
                          {{ redaktion_logo_small(service.redaktion_icon) }}
                        {% endif %}
                        {{ service.redaktion_label }}
                        {% if service.leistungsschluessel %}
                          <span> • </span>
                          {{ service.leistungsschluessel }}
                        {% endif %}
                        {% if service.typisierung %}
                          <span> • </span>{{ service.typisierung }}
                        {% endif %}
                        {% if service.header_date_string %}
                          <span> • </span>{{ service.header_date_string }}
                        {% endif %}
                      </span>
                    </div>
                  </article>
                {%- endfor -%}
              {%- elif filters.resource.value == "process" -%}
                {%- for process in search_result.results -%}
                  <article class="search-result">
                    <a href="{{ process.detail_link }}" class="link-dark">
                      <h3 class="fs-5 fw-semibold mb-0">{{ process.name }}</h3>
                    </a>
                    {{ search_result_description(process.beschreibung) }}
                    <div
                      class="d-flex justify-content-between align-items-center flex-wrap gap-2"
                    >
                      <span class="text-muted">
                        <span
                          >{{ process.id }} • Version {{ process.version }} •
                          {{ process.letzter_aenderungszeitpunkt }}</span
                        >
                      </span>
                      <div class="d-flex flex-row flex-wrap gap-2">
                        {{ freigabestatus_badge(process.freigabe_status) }}
                      </div>
                    </div>
                  </article>
                {%- endfor -%}
              {%- elif filters.resource.value == "sampleprocess" -%}
                {%- for process in search_result.results -%}
                  <article class="search-result">
                    <a href="{{ process.detail_link }}" class="link-dark">
                      <h3 class="fs-5 fw-semibold mb-0">{{ process.name }}</h3>
                    </a>
                    {{ search_result_description(process.beschreibung) }}
                    <div
                      class="d-flex justify-content-between align-items-center flex-wrap gap-2"
                    >
                      <span class="text-muted">
                        <span
                          >{{ process.id }} • Version {{ process.version }} •
                          {{ process.letzter_aenderungszeitpunkt }}</span
                        >
                      </span>
                      <div class="d-flex flex-row flex-wrap gap-2">
                        {{ freigabestatus_badge(process.freigabe_status) }}
                      </div>
                    </div>
                  </article>
                {%- endfor -%}
              {%- elif filters.resource.value == "processclass" -%}
                {%- for processclass in search_result.results -%}
                  <article class="search-result">
                    <a href="{{ processclass.detail_link }}" class="link-dark">
                      <h3 class="fs-5 fw-semibold mb-0">
                        {{ processclass.name }}
                      </h3>
                    </a>
                    {{ search_result_description(processclass.beschreibung) }}
                    <div
                      class="d-flex justify-content-between align-items-center flex-wrap gap-2"
                    >
                      <span class="text-muted">
                        <span
                          >{{ processclass.id }} • Version
                          {{ processclass.version }} •
                          {{ processclass.letzter_aenderungszeitpunkt }}</span
                        >
                      </span>
                      <div class="d-flex flex-row flex-wrap gap-2">
                        {{ freigabestatus_badge(processclass.freigabe_status) }}
                      </div>
                    </div>
                  </article>
                {%- endfor -%}
              {%- endif -%}
            </div>

            <nav
              class="d-flex justify-content-center"
              aria-label="Navigation Ergebnisseiten"
            >
              <ul class="pagination">
                {% if pagination.first_page %}
                  <li class="page-item">
                    <a class="page-link" href="{{ pagination.first_page.href }}"
                      >Erste Seite</a
                    >
                  </li>
                {% else %}
                  <li class="page-item disabled">
                    <span class="page-link">Erste Seite</span>
                  </li>
                {% endif %}
                {% for page in pagination.previous_pages %}
                  <li class="page-item">
                    <a class="page-link" href="{{ page.href }}"
                      >{{ page.label }}</a
                    >
                  </li>
                {% endfor %}
                <li class="page-item active" aria-current="page">
                  <span class="page-link"
                    >{{ pagination.current_page.label }}</span
                  >
                </li>
                {% for page in pagination.next_pages %}
                  <li class="page-item">
                    <a class="page-link" href="{{ page.href }}"
                      >{{ page.label }}</a
                    >
                  </li>
                {% endfor %}
                {% if pagination.last_page %}
                  <li class="page-item">
                    <a class="page-link" href="{{ pagination.last_page.href }}"
                      >Letzte Seite</a
                    >
                  </li>
                {% else %}
                  <li class="page-item disabled">
                    <span class="page-link">Letzte Seite</span>
                  </li>
                {% endif %}
              </ul>
            </nav>
          {% else %}
            <div class="d-flex align-items-center justify-content-center p-5">
              Keine Ergebnisse gefunden.
            </div>
          {% endif %}
        </section>
      </div>
    </form>
  </div>
{% endblock %}
{% block extra_js %}
  <script src="{{ get_static_url('/js/htmx.min.js') }}"></script>
  <script src="{{ get_static_url('/js/init-tooltips.js') }}"></script>
{% endblock %}
